<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title>contracts/index.js - Documentation</title>

    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav>
    <li class="nav-link nav-home-link"><a href="index.html">Home</a></li><li class="nav-heading">Tutorials</li><li class="nav-item"><a href="tutorial-AccountMethods.html">Account Methods</a></li><li class="nav-item"><a href="tutorial-AddCustomProvider.html">Add Custom Provider</a></li><li class="nav-item"><a href="tutorial-AddWalletKeys.html">Add Wallet Keys</a></li><li class="nav-item"><a href="tutorial-AdminContracts.html">Admin contracts interfaces</a></li><li class="nav-item"><a href="tutorial-ChooseProviders.html">Choose Providers</a></li><li class="nav-item"><a href="tutorial-Conversions.html">Utils for conversions</a></li><li class="nav-item"><a href="tutorial-CreateWalletAccount.html">Create new wallet account</a></li><li class="nav-item"><a href="tutorial-EstimateGas.html">Estimate gas and costs</a></li><li class="nav-item"><a href="tutorial-HDwallet.html">Import keys from mnemonic</a></li><li class="nav-item"><a href="tutorial-OperationsContracts.html">Operations contracts interfaces</a></li><li class="nav-item"><a href="tutorial-Query.html">Query</a></li><li class="nav-item"><a href="tutorial-QuickStart.html">QuickStart</a></li><li class="nav-item"><a href="tutorial-USD.html">USD contract interface </a></li><li class="nav-item"><a href="tutorial-Withdrawals.html">Withdrawals</a></li><li class="nav-heading">Classes</li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="Accounts.html">Accounts</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="Accounts.html#.getAccounts">getAccounts</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="Accounts.html#.getBalance">getBalance</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="Accounts.html#.getBalances">getBalances</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="Accounts.html#.importFromSeed">importFromSeed</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="Accounts.html#.transfer">transfer</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="Accounts.html#.transferFrom">transferFrom</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="Contract.html">Contract</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="ContractsConfiguration.html">ContractsConfiguration</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="pm.html">pm</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="pm.contracts.html">contracts</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="pm.provider.html">provider</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="pm.providers.html">providers</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="pm.utils.html">utils</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.utils.html#.fromToken">fromToken</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.utils.html#.isTransactionHash">isTransactionHash</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.utils.html#.sha256">sha256</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.utils.html#.toToken">toToken</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="pm.wallet.html">wallet</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="Provider.html">Provider</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="ProviderConfiguration.html">ProviderConfiguration</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="ProviderConfigurationFiles.html">ProviderConfigurationFiles</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="PublicMint.html">PublicMint</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="PublicMint.html#.provider">provider</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="PublicMint.html#.providers">providers</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="PublicMint.html#.versions">versions</a></span></li><li class="nav-heading">Modules</li><li class="nav-heading"><span class="nav-item-type type-module">M</span><span class="nav-item-name"><a href="module-Contracts.html">Contracts</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="module-Contracts.html#~InvalidAbiException">InvalidAbiException</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="module-Contracts.html#~InvalidAddressException">InvalidAddressException</a></span></li><li class="nav-heading"><span class="nav-item-type type-module">M</span><span class="nav-item-name"><a href="module-Providers.html">Providers</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="module-Providers.html#~getProviderList">getProviderList</a></span></li><li class="nav-heading"><span class="nav-item-type type-module">M</span><span class="nav-item-name"><a href="pm.query.module_Query.html">Query</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.query.module_Query.html#~getWithdrawalTxByContract">getWithdrawalTxByContract</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.query.module_Query.html#~getWithdrawalTypeByContract">getWithdrawalTypeByContract</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.query.module_Query.html#~InvalidArgumentException">InvalidArgumentException</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.query.module_Query.html#~InvalidContractException">InvalidContractException</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.query.module_Query.html#~TransactionException">TransactionException</a></span></li><li class="nav-heading"><span class="nav-item-type type-module">M</span><span class="nav-item-name"><a href="pm.utils.module_Conversions.html">Conversions</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.utils.module_Conversions.html#~Conversions">Conversions</a></span></li><li class="nav-heading"><a href="global.html">Globals</a></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_checkListener">_checkListener</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_createTxObject">_createTxObject</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_decodeEventABI">_decodeEventABI</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_decodeMethodReturn">_decodeMethodReturn</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_encodeEventABI">_encodeEventABI</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_encodeMethodABI">_encodeMethodABI</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_executeMethod">_executeMethod</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_generateEventOptions">_generateEventOptions</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_getCallback">_getCallback</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_getOrSetDefaultOptions">_getOrSetDefaultOptions</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_on">_on</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_processExecuteArguments">_processExecuteArguments</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#clone">clone</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#deploy">deploy</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#getPastEvents">getPastEvents</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#InvalidProviderException">InvalidProviderException</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#once">once</a></span></li>
</nav>

<div id="main">
    
    <h1 class="page-title">contracts/index.js</h1>
    

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
 * PublicMint contracts interface
 * This module resolves configurations of contracts and create interface in `web3.pm.contracts`
 * @example `const { USD } = web3.pm.contracts.token`;
 * @module Contracts
 */

import get from 'lodash/get';
import isEmpty from 'lodash/isEmpty';
import flatten from 'lodash/flatten';
import reduce from 'lodash/reduce';
import upperFirst from 'lodash/upperFirst';
import find from 'lodash/find';


import tokensConfig from './tokens/config';
import adminConfig from './admin/config';
import operationsConfig from './operations/config';
import BaseContract from './web3-lib/contract/index';

// CONTRACTS ABI
import ERC20 from './tokens/abi/ERC20.json';
import GNOSIS from './admin/abi/GNOSIS.json';
import GasManager from './operations/abi/GasManager.json';
import GasManagerPseudoEvents from './operations/abi/GasManagerPseudoEvents.json';

/**
 * Address exception - address invalid or null
 * @param {string} message Error message
 */
function InvalidAddressException(message) {
  this.message = message;
  this.name = 'InvalidAddressException';
}

/**
 * ABI exception - invalid or undefined
 * @param {string} message Error message
 */
function InvalidAbiException(message) {
  this.message = message;
  this.name = 'InvalidAbiException';
}

/**
 * Load generic contracts scheme with custom abi
 * @access private
 * @param {*} contractConfig
 * @param {*} isAddress
 * @param {*} chainId
 * @param {*} abi
 */
const loadGenericContractScheme = (contractConfig, isAddress, chainId, abiList) => {
  return contractConfig.map(config => {
    let targetAddress;
    if (config.deployType === 'genesis') {
      targetAddress = config.deployInfo[0].address;
    } else {
      targetAddress = config.deployInfo.filter(add => add.chainId === chainId)[0].address;
    }

    if (!targetAddress || !isAddress(targetAddress))
      throw new InvalidAddressException('Invalid address in contract configuration file');

    let abi

    if (Array.isArray(config.abi)) {
      abi = config.abi
    } else {
      abi = find(abiList, (abi) => {
        return abi.name === config.abi
      });

      abi = abi ? abi.data : null
    }

    if (!abi) {
      throw new InvalidAbiException('Contract ABI not found or invalid');
    }

    return Object.assign(config, {
      address: targetAddress,
      abi: abi
    });
  });
};
/**
 * Group all contracts configuration to create namespace object
 * @access private
 * @param  {...any} args
 */
const loadConfigs = (isAddress, chainId) => {
  // admin needs to load after all contracts
  const configs = [{
      name: 'operations',
      namespaceConfig: operationsConfig
    },
    {
      name: 'token',
      namespaceConfig: tokensConfig
    }, {
      name: 'admin',
      namespaceConfig: adminConfig
    },
  ];

  const contractsABI = [{
    name: "GasManager",
    data: [...GasManager, ...GasManagerPseudoEvents]
  }, {
    name: "ERC20",
    data: ERC20,
  }, {
    name: "GNOSIS",
    data: GNOSIS
  }];

  return configs.map((cfg) => {
    return Object.assign(cfg, {
      contracts: loadGenericContractScheme(cfg.namespaceConfig, isAddress, chainId, contractsABI)
    });
  });
}

/**
 * This will wrap multi sig `submitTransaction` for target contract like USD
 * This will prefix all methods that contract admins transforming the first
 * letter in uppercase and add a prefix with `proxy` word.
 * Using `web3.pm.contracts.admin.proxyDeposit(&lt;depositArgs>)`
 * @access private
 * @throws - All web3 errors and exceptions
 * @param {*} contracts all created contracts before
 * @param {*} adminsTo property inside current contract
 * @param {*} currentContract current contract methods
 * @return {Array.&lt;Object>}
 * @example `returns [{ deposit: [Function: deposit] } ]`
 */
const resolveAdminMethods = (contracts, {
  adminsTo
}, currentContract) => {
  if (adminsTo) {
    const listOfMethodsResolved = flatten(
      adminsTo.map(adminContract => {
        const adminMethods = get(contracts, adminContract.target, 'null');
        return Object.keys(adminMethods)
          .filter(key => adminContract.proxyMethods.includes(key))
          .map(methodKey => {
            return {
              [`proxy${upperFirst(methodKey)}`]: (...args) => {
                const target = adminMethods.options.address;
                let encodedData = null;
                try {
                  encodedData = adminMethods[methodKey](...args).encodeABI();
                } catch (error) {
                  return error;
                }
                return currentContract.submitTransaction(target, 0, encodedData);
              }
            };
          });
      })
    );

    return reduce(listOfMethodsResolved, (methods, current) => {
      return Object.assign(methods, current);
    });
  }
  return null;
};


/**
 * Should create a interface of contracts in configuration file,
 * passing the methods directly to root (we can use web3 style using prefix of `methods`) of object with name given.
 * @private
 * @param {*} web3in web3 instance
 * @param {*} chainId selected chain id
 * @param {*} opts custom contract options
 */
const createContractsInterface = (web3in, chainId, opts = {}) => {
  const {
    isAddress
  } = web3in.utils;

  const namespaceConfigs = loadConfigs(isAddress, chainId);
  const contracts = {};
  // loop all namespaces configs
  namespaceConfigs.forEach(namespaceConfig => {
    // load all contracts for parent namespace
    return namespaceConfig.contracts.forEach(co => {

      const ContextContract = BaseContract.bind(web3in.eth)
      BaseContract.setProvider(web3in.currentProvider, web3in.eth.accounts);

      const instance = new ContextContract(co.abi, co.address, opts);
      let {
        methods
      } = instance;

      // load proxy admin methods for multiSig wallets
      const adminMethods = resolveAdminMethods(contracts, co, methods);

      if (!isEmpty(adminMethods)) {
        methods = Object.assign(methods, adminMethods);
      }

      const contractsNamespace = contracts[namespaceConfig.name];
      const contractsNamespaceValue = !contractsNamespace ? {} : contractsNamespace;

      contracts[namespaceConfig.name] = Object.assign(contractsNamespaceValue, {
        [co.name]: {
          ...instance,
          ...methods
        }
      });
    });
  });
  return contracts;
};

export default createContractsInterface;
</code></pre>
        </article>
    </section>




</div>

<br class="clear">

<footer>
    Generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.3</a> on Fri Feb 21 2020 12:09:02 GMT+0000 (Western European Standard Time) using the Minami theme.
</footer>

<script>prettyPrint();</script>
<script src="scripts/linenumber.js"></script>
</body>
</html>
